require 'gosu'
require 'chipmunk'

class Ball
  attr_reader :body, :shape
  
  def initialize(space, image)
    @body = CP::Body.new(1.0,1.0)
    @shape = CP::Shape::Circle.new(@body,22.0/2, CP::Vec2.new(0,0))
    @image = image

    @shape.body.pos = CP::Vec2.new(SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2) #position
    @shape.e = 1.0 #elasticity
    @shape.u = 0.1 #friction
    @shape.collision_type = :ball
    @shape.body.apply_impulse(CP::Vec2.new(0.0,0.0), CP::Vec2.new(0.1,0))
    space.add_body(@body)
    space.add_shape(@shape)
  end

  def draw
    @image.draw_rot(@shape.body.pos.x,@shape.body.pos.y,1,@shape.body.a.radians_to_gosu, 0.5, 0.5, 1, 1)
  end
end