require 'gosu'
require 'chipmunk'

class Player
  attr_reader :body, :shape
  SPEED = 10.0

  def initialize(space, image)
    @body = CP::Body.new(1.0, 1.0)
    verts = Array.new
    verts.push(CP::Vec2.new(0,32))
    verts.push(CP::Vec2.new(32,32))
    verts.push(CP::Vec2.new(32,0))
    verts.push(CP::Vec2.new(0,0))

    @shape = CP::Shape::Poly.new(@body, verts, CP::Vec2.new(0,0))
    @image = image

    @shape.body.pos = CP::Vec2.new((SCREEN_WIDTH / 2) - 50, (SCREEN_HEIGHT / 2) - 50)
    @shape.e = 0.2 #elasticity
    @shape.u = 10.1 #friction
    @shape.collision_type = :player
    @shape.body.apply_impulse(CP::Vec2.new(0.0, 0.0), CP::Vec2.new(0.1, 0.0))
    space.add_body(@body)
    space.add_shape(@shape)
  end

  def draw
    @image.draw(@shape.body.pos.x, @shape.body.pos.y, 1) # we don't want the player to rotate
    #@image.draw_rot(@shape.body.pos.x, @shape.body.pos.y, 1, @shape.body.a.radians_to_gosu, 0.5, 0.5, 1, 1)
  end

  def move_left
    @shape.body.apply_impulse(CP::Vec2.new(-SPEED, 0.0), CP::Vec2.new(0.0, 0.0))
  end
  
	def move_right
    @shape.body.apply_impulse(CP::Vec2.new(SPEED, 0.0), CP::Vec2.new(0.0, 0.0))
  end

	def move_up
		@shape.body.apply_impulse(CP::Vec2.new(0.0, -SPEED), CP::Vec2.new(0.0, 0.0))
  end

  def move_down
    @shape.body.apply_impulse(CP::Vec2.new(0.0, SPEED), CP::Vec2.new(0.0, 0.0))
  end

end